#include "MainComponent.h"

//==============================================================================
MainComponent::MainComponent() {
	createOpenGLContext();
	
    setSize (600, 400);
}

MainComponent::~MainComponent() {
	detachOpenGlContext();
}

void MainComponent::createOpenGLContext() {
	openGLContext.setOpenGLVersionRequired(juce::OpenGLContext::openGL3_2);
	openGLContext.setMultisamplingEnabled(true);
	openGLContext.setComponentPaintingEnabled(true);
	openGLContext.attachTo (*getTopLevelComponent());
}

void MainComponent::detachOpenGlContext() {
	openGLContext.detach();
}

void MainComponent::createImage() {
	img = juce::Image(juce::Image::ARGB,
					  600, 3500, true,
					  juce::OpenGLImageType());
	graphics = std::make_unique<juce::Graphics>(img);
	graphics->setColour(juce::Colours::white);
	graphics->fillAll();
}

void MainComponent::replaceImage() {
	graphics.reset();
	img = juce::Image(juce::Image::ARGB,
					  600, 3500, true,
					  juce::OpenGLImageType());
	graphics = std::make_unique<juce::Graphics>(img);
	graphics->setColour(juce::Colours::white);
	graphics->fillAll();
}

//==============================================================================
void MainComponent::paint (juce::Graphics& g) {
	createImage();
	replaceImage();
	g.drawImage(img, 0, 0, img.getWidth(), img.getHeight(), 0, 0, img.getWidth(), img.getHeight());
}

void MainComponent::resized() {
    // This is called when the MainComponent is resized.
    // If you add any child components, this is where you should
    // update their positions.
}
