#pragma once

#include <JuceHeader.h>

//==============================================================================
/*
    This component lives inside our window, and this is where you should put all
    your controls and content.
*/
class MainComponent  : public juce::Component
{
public:
    //==============================================================================
    MainComponent();
    ~MainComponent() override;

    //==============================================================================
    void paint (juce::Graphics&) override;
    void resized() override;

private:
	void createOpenGLContext();
	void detachOpenGlContext();
	void createImage();
	void replaceImage();
    //==============================================================================
    // Your private member variables go here...
	juce::Image img;
	std::unique_ptr<juce::Graphics> graphics;
	juce::OpenGLContext openGLContext;

    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (MainComponent)
};
